HDU - 1298——T9 (九宫格拼音模拟)

A while ago it was quite cumbersome to create a message for the Short Message Service (SMS) on a mobile phone. This was because you only have nine keys and the alphabet has more than nine letters, so most characters could only be entered by pressing one key several times. For example, if you wanted to type "hello" you had to press key 4 twice, key 3 twice, key 5 three times, again key 5 three times, and finally key 6 three times. This procedure is very tedious and keeps many people from using the Short Message Service.

This led manufacturers of mobile phones to try and find an easier way to enter text on a mobile phone. The solution they developed is called T9 text input. The "9" in the name means that you can enter almost arbitrary words with just nine keys and without pressing them more than once per character. The idea of the solution is that you simply start typing the keys without repetition, and the software uses a built-in dictionary to look for the "most probable" word matching the input. For example, to enter "hello" you simply press keys 4, 3, 5, 5, and 6 once. Of course, this could also be the input for the word "gdjjm", but since this is no sensible English word, it can safely be ignored. By ruling out all other "improbable" solutions and only taking proper English words into account, this method can speed up writing of short messages considerably. Of course, if the word is not in the dictionary (like a name) then it has to be typed in manually using key repetition again.


Figure 8: The Number-keys of a mobile phone.


More precisely, with every character typed, the phone will show the most probable combination of characters it has found up to that point. Let us assume that the phone knows about the words "idea" and "hello", with "idea" occurring more often. Pressing the keys 4, 3, 5, 5, and 6, one after the other, the phone offers you "i", "id", then switches to "hel", "hell", and finally shows "hello".

Write an implementation of the T9 text input which offers the most probable character combination after every keystroke. The probability of a character combination is defined to be the sum of the probabilities of all words in the dictionary that begin with this character combination. For example, if the dictionary contains three words "hell", "hello", and "hellfire", the probability of the character combination "hell" is the sum of the probabilities of these words. If some combinations have the same probability, your program is to select the first one in alphabetic order. The user should also be able to type the beginning of words. For example, if the word "hello" is in the dictionary, the user can also enter the word "he" by pressing the keys 4 and 3 even if this word is not listed in the dictionary.
Input The first line contains the number of scenarios.

Each scenario begins with a line containing the number w of distinct words in the dictionary (0<=w<=1000). These words are given in the next w lines. (They are not guaranteed in ascending alphabetic order, although it's a dictionary.) Every line starts with the word which is a sequence of lowercase letters from the alphabet without whitespace, followed by a space and an integer p, 1<=p<=100, representing the probability of that word. No word will contain more than 100 letters.

Following the dictionary, there is a line containing a single integer m. Next follow m lines, each consisting of a sequence of at most 100 decimal digits 2-9, followed by a single 1 meaning "next word".
Output The output for each scenario begins with a line containing "Scenario #i:", where i is the number of the scenario starting at 1.

For every number sequence s of the scenario, print one line for every keystroke stored in s, except for the 1 at the end. In this line, print the most probable word prefix defined by the probabilities in the dictionary and the T9 selection rules explained above. Whenever none of the words in the dictionary match the given number sequence, print "MANUALLY" instead of a prefix.

Terminate the output for every number sequence with a blank line, and print an additional blank line at the end of every scenario.
Sample Input
2
5
hell 3
hello 4
idea 8
next 8
super 3
2
435561
43321
7
another 5
contest 6
follow 3
give 13
integer 6
new 14
program 4
5
77647261
6391
4681
26684371
77771
Sample Output
Scenario #1:
i
id
hel
hell
hello

i
id
ide
idea


Scenario #2:
p
pr
pro
prog
progr
progra
program

n
ne
new

g
in
int

c
co
con
cont
anoth
anothe
another

p
pr
MANUALLY
MANUALLY

题意:输入字符串优先级,输出数字串中对应九宫数字键的拼音优先级最高的,优先级相等按字典序。

思路:简单的字典树模拟题,放置好优先级,再搜索就行了。有个坑点wa了一天,一直RE,以为是内存超限,然后疯狂改代码,后来发现是因为它的输入中有1的情况存在,可题意写明是2—9,以1结尾。

#include<iostream>
#include<stdio.h>
#include<algorithm>
#include<string.h>
using namespace std;
char a[105],x,b[105],ans[105];
int ansp;
char pan[10][5]= {"","","abc#","def#","ghi#","jkl#","mno#","pqrs","tuv#","wxyz"};
struct Trie
{
    int v;
    Trie *next[26];
};
Trie root;
int  cteate_Trie(int x)
{
    Trie *p=&root,*q;
    int len=strlen(a);
    for(int i=0; i<len; i++)
    {
        int di=a[i]-'a';
        if(p->next[di]==NULL)
        {
            q=new Trie;
            for(int i=0; i<26; i++)
            {
                q->next[i]=NULL;
            }
            q->v=0;
            p->next[di]=q;
        }
        p=p->next[di];
        (p->v)+=x;
    }
}
int  find_Trie(Trie *heat,char *ttx,int l)
{
    if(l>105)
        return 0;
    if(b[l]=='\0')
    {
        if(ansp<heat->v)
        {
            ttx[l]='\0';
            ansp=heat->v;
            strcpy(ans,ttx);
            return 0;
        }
    }
    if(b[l]<'2'||b[l]>'9')//不加这个判断就直接RE
        return 0;
    int pi=b[l]-'0';
    for(int i=0; i<4; i++)
    {
        if(pan[pi][i]!='#')
        {
            int di=pan[pi][i]-'a';
            if(heat->next[di]!=NULL)
            {
                ttx[l]=pan[pi][i];
                find_Trie(heat->next[di],ttx,l+1);
            }
        }

    }
}
int main()
{
    char ttx[105];
    int t,n,m,ph=1;
    scanf("%d",&t);
    while(t--)
    {
        for(int i=0; i<26; i++)
        {
            root.next[i]=NULL;
        }
        root.v=0;
        scanf("%d",&n);
        while(n--)
        {
            scanf("%s%d",a,&x);
            cteate_Trie(x);
        }
        printf("Scenario #%d:\n",ph++);
        scanf("%d",&m);
        while(m--)
        {
            scanf("%s",a);
            int len=strlen(a);
            for(int i=1; i<len; i++)
            {
                memset(ttx,0,sizeof(ttx));
                ansp=0;
                strncpy(b,a,i);
                b[i]='\0';
                find_Trie(&root,ttx,0);
                if(ansp==0)
                    printf("MANUALLY\n");
                else
                    printf("%s\n",ans);
            }
            printf("\n");
        }
        printf("\n");
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/weixin_41380961/article/details/80243785